@ECHO OFF
:: Script for creating UltraVNC SC package

:: Command line syntax: create_exe.cmd customzip    (customzip.zip being the name of the zip file)
:: you may also choose an exe name different than the zip file by passing a second parameter as the exe name
:: ie: create_exe.cmd customzip mynewfile       (customzip.zip being the zip file and mynewfile.exe being the resulting exe name)

:: The following files and directories should exist prior to running this
:: C:\UVNCSC\
:: C:\UVNCSC\BIN\    executables required to create the package
:: C:\UVNCSC\INC\    file required as part
:: C:\UVNCSC\WORK\

SET PATH = %path%;C:\UVNCSC\BIN
C:
CD\
CD UVNCSC

:: Clean out the work directory and temp files
DEL C:\UVNCSC\WORK\*.* /q
DEL C:\UVNCSC\archive.exe /q
DEL C:\UVNCSC\archive_temp.exe /q
DEL C:\UVNCSC\*.bak /q
DEL C:\UVNCSC\*.log /q
DEL C:\UVNCSC\*.exe /q
DEL C:\UVNCSC\*.rc /q
DEL C:\UVNCSC\*.res /q

:: Check for existence of zip file
IF NOT EXIST C:\UVNCSC\%1.zip CLS
IF NOT EXIST C:\UVNCSC\%1.zip ECHO.
IF NOT EXIST C:\UVNCSC\%1.zip ECHO C:\UVNCSC\%1.zip NOT FOUND
IF NOT EXIST C:\UVNCSC\%1.zip GOTO FIN

:: Copy the include file to the work directory
COPY C:\UVNCSC\INC\*.* C:\UVNCSC\WORK\*.* /y

:: Extract the zip file to the Work directory
C:\UVNCSC\BIN\7z.exe e %1.zip -y -oC:\UVNCSC\WORK *.*


:: Copy the icon and version resource files to the UVNCSC root directory
IF EXIST C:\UVNCSC\WORK\VERSION.RC MOVE C:\UVNCSC\WORK\VERSION.RC C:\UVNCSC\
IF NOT EXIST C:\UVNCSC\VERSION.RC COPY C:\UVNCSC\CUSTOM\VERSION.RC C:\UVNCSC\
IF NOT EXIST C:\UVNCSC\ICON.RC COPY C:\UVNCSC\CUSTOM\ICON.RC C:\UVNCSC\
IF EXIST C:\UVNCSC\WORK\ICON1.ICO COPY C:\UVNCSC\WORK\ICON1.ICO C:\UVNCSC\
IF NOT EXIST C:\UVNCSC\ICON1.ICO COPY C:\UVNCSC\INC\ICON1.ICO C:\UVNCSC\


:: Generate the Resource Files (.RES)
C:\UVNCSC\BIN\gorc.exe /r icon.rc
C:\UVNCSC\BIN\gorc.exe /r version.rc


:: Create the archive file
CD WORK
C:\UVNCSC\BIN\7z.exe a -t7z archive.7z -r- * -mx=9
CD ..


:: Create SFX Module for installer
COPY /b c:\uvncsc\bin\7zSD.sfx + c:\uvncsc\config.txt + c:\uvncsc\work\archive.7z c:\uvncsc\archive.exe


:: Modify icon of exe file
COPY C:\UVNCSC\WORK\icon1.ico C:\UVNCSC\icon1.ico /y
C:\UVNCSC\BIN\ResHacker.exe -script C:\UVNCSC\reshack.txt


:: Compact the Exe
C:\UVNCSC\BIN\upx.exe -9 archive_temp.exe


:: Rename the temporary exe to the final name
IF '%2' NEQ '' REN archive_temp.exe %2.exe
IF '%2' == '' REN archive_temp.exe %1.exe

DEL C:\UVNCSC\archive.exe /q
DEL C:\UVNCSC\icon1.ico /q
DEL C:\UVNCSC\*.rc /q
DEL C:\UVNCSC\*.res /q
DEL C:\UVNCSC\*.log /q

:FIN
